--- /usr/bin/dpkg-source	2011-04-16 03:54:49.000000000 +0200
+++ ./dpkg-source	2011-05-06 01:41:43.000000000 +0200
@@ -113,7 +113,7 @@
 	"options" => qr/^--(?:format=|unapply-patches$|abort-on-upstream-changes$)/,
 	"local-options" => qr/^--format=/,
     };
-    foreach my $filename ("local-options", "options") {
+    foreach my $filename ("options", "local-options") {
 	my $conf = Dpkg::Conf->new();
 	my $optfile = File::Spec->catfile($dir, "debian", "source", $filename);
 	next unless -f $optfile;
@@ -122,7 +122,7 @@
 	if (@$conf) {
 	    info(_g("using options from %s: %s"), $optfile, join(" ", @$conf))
 		unless $options{'opmode'} eq "--print-format";
-	    unshift @options, @$conf;
+	    push @options, @$conf;
 	}
     }
 }
@@ -157,7 +157,11 @@
     } elsif (m/^-(?:i|-diff-ignore(?:$|=))(.*)$/) {
         $options{'diff_ignore_regexp'} = $1 ? $1 : $Dpkg::Source::Package::diff_ignore_default_regexp;
     } elsif (m/^--extend-diff-ignore=(.+)$/) {
-	$Dpkg::Source::Package::diff_ignore_default_regexp .= "|$1";
+        if ($options{'diff_ignore_regexp'}) {
+            $options{'diff_ignore_regexp'} .= "|$1";
+        } else {
+            $options{'diff_ignore_regexp'} = $Dpkg::Source::Package::diff_ignore_default_regexp . "|$1";
+        }
     } elsif (m/^-(?:I|-tar-ignore=)(.+)$/) {
         push @{$options{'tar_ignore'}}, $1;
     } elsif (m/^-(?:I|-tar-ignore)$/) {
